---------------------------------------------------------
---------------------------------------------------------
---------------------------------------------------------

----- TABLE -----

ws_weapon={
		--- [weaponID]=wall-limit
		[31]=1.5; --- just example with SG552
	}


----- FUNCTIONS -----

function ws_hitplayer(id,pl,wpnname,dmg,wpid) -- id=victim, pl=attacker
       if wpid==nil or wpid<=0 then wpid=false end
       if id and id>0 then
             if wpnname==nil or not wpnname then
                   wpnname="1Hit"
             end
             if not dmg then
                   dmg=0
             end
             if dmg>=(player(id,"health")) then
                     if pl~=nil and pl>0 and player(pl,"exists") then
                        wn="Wallshot"
                        wi="gfx/gui_server.bmp.bmp"
                        if wpid then
                           wi="gfx/weapons/"..itemtype(wpid,"name").."_k.bmp"
                           wn=itemtype(wpid,"name")
                        end
                        parse('customkill '..pl..' "'..wn..','..wi..'" '..id)
                     else
                        parse('customkill 0 "'..wpnname..'" '..id)
                     end
             elseif dmg<(player(id,"health")) then
                     parse("sethealth "..id.." "..(player(id,"health")-dmg))
             end
        end
end

function ws_checkblockpl(id,x,y,s)
         if s==nil or not s then return {0,false} end
         if not tonumber(id) then id=0 end
         x=math.floor(x/32)
         y=math.floor(y/32)
         for _,i in pairs(player(0,"tableliving")) do
               if player(i,"tilex")==x and player(i,"tiley")==y and i~=id then
                      return {i,true}
               end
         end
         return {0,false}
end      

function ws_checkblockpos(x1,y1,rot1,id,max,pls,tileblock,objectblock)
      tilevalue,tilevalueid="walkable",true
      if pls==nil then pls=false end
      if tileblock and tileblock[1] and tonumber(tileblock[2]) and (tileblock[1]=="frame" or tileblock[1]=="property") then
          tilevalue,tilevalueid=tileblock[1],tonumber(tileblock[2])
      elseif tileblock and tileblock[1] and tileblock[2]~=nil then
          tilevalue,tilevalueid=tileblock[1],tileblock[2]
      elseif tileblock then
          tilevalue=tileblock
      end
      if not tonumber(id) then id=ws_checkblockpl(0,x1,y1,pls)[1] end
      if not tonumber(objectblock) then objectblock=30 end
      local rot,x,y,dist=(rot1-90)*math.pi/180,x1,y1,0
      if tonumber(max) and max>0 then
         maxs=0
         while (tile(math.floor(x/32),math.floor(y/32),tilevalue)==tilevalueid) and objectat(math.floor(x/32),math.floor(y/32),objectblock)==0 and not ws_checkblockpl(id,x,y,pls)[2] and maxs<max do
               maxs=maxs+16
               dist=dist+16
               x=x+math.cos(rot)*16
               y=y+math.sin(rot)*16
         end
      else
         while (tile(math.floor(x/32),math.floor(y/32),tilevalue)==tilevalueid) and objectat(math.floor(x/32),math.floor(y/32),objectblock)==0 and not ws_checkblockpl(id,x,y,pls)[2] do
               dist=dist+16
               x=x+math.cos(rot)*16
               y=y+math.sin(rot)*16
         end
      end
      return {x=x,y=y,lastrot=rot1,player=ws_checkblockpl(id,x,y,pls)[1],dis=dist}
end

----- HOOK -----

addhook("attack","ws_atk")
function ws_atk(id)
           local thewp=player(id,"weapon")
           if ws_weapon[thewp]~=nil and ws_weapon[thewp] then
                local getwall=false
                local rot,x,y=player(id,"rot"),player(id,"x"),player(id,"y")
                getb=ws_checkblockpos(x,y,rot,id,(10*32),false,{"wall",false})
                getbcp=ws_checkblockpos(x,y,rot,id,(10*32),true,{"wall",false})
		if getbcp.player~=nil and getbcp.player>0 then
                   return false
                end
                x,y=getb.x,getb.y
                getb2=ws_checkblockpos(getb.x,getb.y,rot,id,(32*ws_weapon[thewp]),true,"wall")
                x,y=getb2.x,getb2.y
                if (tile(math.floor(x/32),math.floor(y/32),"wall")==false) and
                   (tile(math.floor(getb.x/32),math.floor(getb.y/32),"wall")==true) then
                   parse('effect "smoke" '..x..' '..y..' 1 1 000 000 000')
                   getwall=true
                end
                local getb3=ws_checkblockpos(x,y,rot,id,(10*32),true,{"wall",false})
                local getb32=ws_checkblockpos(getb3.x,getb3.y,rot,id,32,true)
                if getb3.player>0 then
                   local gdmg=itemtype(player(id,"weapon"),"dmg")
		   parse('effect "colorsmoke" '..getb3.x..' '..getb3.y..' 1 1 255 000 000')
                   if thewp==35 then
                      gdmg=250
                   end
                   if player(getb3.player,"armor")==201 then
                      gdmg=math.floor(75/100*gdmg)
                   elseif player(getb3.player,"armor")==202 then
                      gdmg=math.floor(50/100*gdmg)
                   elseif player(getb3.player,"armor")==203 then
                      gdmg=math.floor(25/100*gdmg)
                   elseif player(getb3.player,"armor")==205 then
                      gdmg=math.floor(5/100*gdmg)
                   end
                   if tonumber(game("sv_friendlyfire"))==0 then
                       mt=player(getb3.player,"team")
                       pt=player(id,"team")
                       if pt==mt then return 1 end
                   end
                   if player(getb3.player,"weapon")~=41 then
                     ws_hitplayer(getb3.player,id,"Wallshot",gdmg,thewp)
                   else
                     ws_hitplayer(getb3.player,id,"Wallshot",(gdmg*0.75),thewp)
                   end
                elseif getwall==true and (tile(math.floor(getb32.x/32),math.floor(getb32.y/32),"wall")==true) then
                end
          end
end